import { ItemStack, world, system, EntityEquippableComponent, EquipmentSlot } from "@minecraft/server";


const itemsToTriggerSpawn = [
    "torch",
    "lantern", "blaze", "magma", "shroomlight", "blaze_rod", "blaze_powder",
    "glowstone", "lit_pumpkin", "campfire", "beacon", "fire_charge", 
    "glowstone_dust", "ochre_froglight", "glow_berries", "pearlescent_froglight",
    "verdant_froglight", "glow", "sea_lantern", "soul_campfire", "soul_lantern",
    "sea_pickle", "glow_ink_sac", "glow_frame", "magma_cream", "magma",
    "echo_shard", "crying_obsidian", "prismarine_crystals", "recovery_compass","lava_bucket"
];



system.runInterval(() => {
    let players = world.getAllPlayers();
    players.forEach(player => {
        const inventoryComponent = player.getComponent("minecraft:inventory");
        const playerEquipment = player.getComponent(EntityEquippableComponent.componentId);
        if (!inventoryComponent || !playerEquipment) return;
        const mainHandItem = playerEquipment.getEquipment(EquipmentSlot.Mainhand);
        const offHandItem = playerEquipment.getEquipment(EquipmentSlot.Offhand);
        const inventory = inventoryComponent.container;
        replaceItems(inventory, "minecraft:torch", "raiyon:torch");
    
        
        if (!player.isgliding && shouldSpawnPig(mainHandItem) || shouldSpawnPig(offHandItem)) {
            player.runCommand("execute as @a  at @s unless block ~ ~1 ~ air run execute positioned ~~1 ~ as @s run function raiyon_luz");
            player.runCommand("execute as @a  at @s if block ~ ~1 ~ air run function raiyon_luz");
        } else {
            player.runCommand('fill ~1 ~2 ~1 ~-1 ~-2 ~-1 air replace light_block ["block_light_level" = 15]');
        }
    });
    let overworld = world.getDimension("overworld");
    let entities = overworld.getEntities();
                entities.forEach(entity => {
               
                if (entity.hasComponent("minecraft:item")) {
                    const itemComponent = entity.getComponent("minecraft:item");
                    
                    
                 
                        const itemStack = itemComponent.itemStack;
                        const itemStackAmount = itemComponent.itemStack.amount;
                      
                     
                        const torch = new ItemStack("raiyon:torch", itemStackAmount);
                        if(itemStack.typeId === 'minecraft:torch'){

                            entity.dimension.spawnItem(torch,entity.location);
                            entity.kill();

                        }
                            
                      
                        

                    }
                
                
                });
   

}, 1);


function shouldSpawnPig(item) {
    return item && itemsToTriggerSpawn.some(typeId => item.typeId.includes(typeId));
}





function replaceItems(inventory, oldTypeId, newTypeId) {
    for (let i = 0; i < inventory.size; i++) {
        const item = inventory.getItem(i);
        if (item && item.typeId === oldTypeId) {
            const newItem = new ItemStack(newTypeId, item.amount);
            inventory.setItem(i, newItem);
        }
    }
}